summaryrefslogtreecommitdiffstats
path: root/11.0
diff options
context:
space:
mode:
authorJ0WI <J0WI@users.noreply.github.com>2018-02-11 02:58:17 +0100
committerJ0WI <J0WI@users.noreply.github.com>2018-02-22 18:07:57 +0100
commit22de97f206a74a931c6e25439bf18ada178e990b (patch)
treef094dc149ff18ebb391bb2ab3679f833ff010d71 /11.0
parent0e76d154a167ece805fbdfe44665011d215ae275 (diff)
Add Alpine variant
Diffstat (limited to '11.0')
-rw-r--r--11.0/fpm-alpine/Dockerfile111
-rw-r--r--11.0/fpm-alpine/config/apcu.config.php4
-rw-r--r--11.0/fpm-alpine/config/apps.config.php15
-rw-r--r--11.0/fpm-alpine/config/autoconfig.php34
-rwxr-xr-x11.0/fpm-alpine/cron.sh4
-rwxr-xr-x11.0/fpm-alpine/entrypoint.sh60
6 files changed, 228 insertions, 0 deletions
diff --git a/11.0/fpm-alpine/Dockerfile b/11.0/fpm-alpine/Dockerfile
new file mode 100644
index 00000000..24997422
--- /dev/null
+++ b/11.0/fpm-alpine/Dockerfile
@@ -0,0 +1,111 @@
+FROM php:7.1-fpm-alpine
+
+# entrypoint.sh dependencies
+RUN apk add --no-cache \
+ bash \
+ coreutils \
+ rsync
+
+# install the PHP extensions we need
+# see https://docs.nextcloud.com/server/12/admin_manual/installation/source_installation.html
+RUN set -ex; \
+ \
+ apk add --no-cache --virtual .build-deps \
+ alpine-sdk \
+ autoconf \
+ freetype-dev \
+ icu-dev \
+ libjpeg-turbo-dev \
+ libmcrypt-dev \
+ libpng-dev \
+ libmemcached-dev \
+ libxml2-dev \
+ openldap-dev \
+ postgresql-dev \
+ ; \
+ \
+ docker-php-ext-configure gd --with-freetype-dir=/usr --with-png-dir=/usr --with-jpeg-dir=/usr; \
+ docker-php-ext-configure ldap; \
+ docker-php-ext-install \
+ exif \
+ gd \
+ intl \
+ ldap \
+ mbstring \
+ mcrypt \
+ mysqli \
+ opcache \
+ pcntl \
+ pdo_mysql \
+ pdo_pgsql \
+ pgsql \
+ zip \
+ ; \
+ pecl install \
+ APCu-5.1.9 \
+ memcached-3.0.4 \
+ redis-3.1.6 \
+ ; \
+ docker-php-ext-enable \
+ apcu \
+ memcached \
+ redis \
+ ; \
+ \
+ runDeps="$( \
+ scanelf --needed --nobanner --format '%n#p' --recursive /usr/local/lib/php/extensions \
+ | tr ',' '\n' \
+ | sort -u \
+ | awk 'system("[ -e /usr/local/lib/" $1 " ]") == 0 { next } { print "so:" $1 }' \
+ )"; \
+ apk add --virtual .nextcloud-phpext-rundeps $runDeps; \
+ apk del .build-deps
+
+# set recommended PHP.ini settings
+# see https://docs.nextcloud.com/server/12/admin_manual/configuration_server/server_tuning.html#enable-php-opcache
+RUN { \
+ echo 'opcache.enable=1'; \
+ echo 'opcache.enable_cli=1'; \
+ echo 'opcache.interned_strings_buffer=8'; \
+ echo 'opcache.max_accelerated_files=10000'; \
+ echo 'opcache.memory_consumption=128'; \
+ echo 'opcache.save_comments=1'; \
+ echo 'opcache.revalidate_freq=1'; \
+ } > /usr/local/etc/php/conf.d/opcache-recommended.ini; \
+ \
+ chown -R www-data:root /var/www/html; \
+ chmod -R g=u /var/www/html
+
+VOLUME /var/www/html
+
+
+ENV NEXTCLOUD_VERSION 11.0.7
+
+RUN set -ex; \
+ apk add --no-cache --virtual .fetch-deps \
+ bzip2 \
+ gnupg \
+ ; \
+ \
+ curl -fsSL -o nextcloud.tar.bz2 \
+ "https://download.nextcloud.com/server/releases/nextcloud-${NEXTCLOUD_VERSION}.tar.bz2"; \
+ curl -fsSL -o nextcloud.tar.bz2.asc \
+ "https://download.nextcloud.com/server/releases/nextcloud-${NEXTCLOUD_VERSION}.tar.bz2.asc"; \
+ export GNUPGHOME="$(mktemp -d)"; \
+# gpg key from https://nextcloud.com/nextcloud.asc
+ gpg --keyserver ha.pool.sks-keyservers.net --recv-keys 28806A878AE423A28372792ED75899B9A724937A; \
+ gpg --batch --verify nextcloud.tar.bz2.asc nextcloud.tar.bz2; \
+ rm -r "$GNUPGHOME" nextcloud.tar.bz2.asc; \
+ tar -xjf nextcloud.tar.bz2 -C /usr/src/; \
+ rm nextcloud.tar.bz2; \
+ rm -rf /usr/src/nextcloud/updater; \
+ mkdir -p /usr/src/nextcloud/data; \
+ mkdir -p /usr/src/nextcloud/custom_apps; \
+ chmod +x /usr/src/nextcloud/occ; \
+ apk del .fetch-deps
+
+COPY entrypoint.sh /
+COPY config/* /usr/src/nextcloud/config/
+
+ENTRYPOINT ["/entrypoint.sh"]
+CMD ["php-fpm"]
diff --git a/11.0/fpm-alpine/config/apcu.config.php b/11.0/fpm-alpine/config/apcu.config.php
new file mode 100644
index 00000000..69fed876
--- /dev/null
+++ b/11.0/fpm-alpine/config/apcu.config.php
@@ -0,0 +1,4 @@
+<?php
+$CONFIG = array (
+ 'memcache.local' => '\OC\Memcache\APCu',
+);
diff --git a/11.0/fpm-alpine/config/apps.config.php b/11.0/fpm-alpine/config/apps.config.php
new file mode 100644
index 00000000..a4bed833
--- /dev/null
+++ b/11.0/fpm-alpine/config/apps.config.php
@@ -0,0 +1,15 @@
+<?php
+$CONFIG = array (
+ "apps_paths" => array (
+ 0 => array (
+ "path" => OC::$SERVERROOT."/apps",
+ "url" => "/apps",
+ "writable" => false,
+ ),
+ 1 => array (
+ "path" => OC::$SERVERROOT."/custom_apps",
+ "url" => "/custom_apps",
+ "writable" => true,
+ ),
+ ),
+);
diff --git a/11.0/fpm-alpine/config/autoconfig.php b/11.0/fpm-alpine/config/autoconfig.php
new file mode 100644
index 00000000..b759f4d1
--- /dev/null
+++ b/11.0/fpm-alpine/config/autoconfig.php
@@ -0,0 +1,34 @@
+<?php
+
+$autoconfig_enabled = false;
+
+if (getenv('SQLITE_DATABASE')) {
+ $AUTOCONFIG["dbtype"] = "sqlite";
+ $AUTOCONFIG["dbname"] = getenv('SQLITE_DATABASE');
+ $autoconfig_enabled = true;
+} elseif (getenv('MYSQL_DATABASE') && getenv('MYSQL_USER') && getenv('MYSQL_PASSWORD') && getenv('MYSQL_HOST')) {
+ $AUTOCONFIG["dbtype"] = "mysql";
+ $AUTOCONFIG["dbname"] = getenv('MYSQL_DATABASE');
+ $AUTOCONFIG["dbuser"] = getenv('MYSQL_USER');
+ $AUTOCONFIG["dbpass"] = getenv('MYSQL_PASSWORD');
+ $AUTOCONFIG["dbhost"] = getenv('MYSQL_HOST');
+ $autoconfig_enabled = true;
+} elseif (getenv('POSTGRES_DB') && getenv('POSTGRES_USER') && getenv('POSTGRES_PASSWORD') && getenv('POSTGRES_HOST')) {
+ $AUTOCONFIG["dbtype"] = "pgsql";
+ $AUTOCONFIG["dbname"] = getenv('POSTGRES_DB');
+ $AUTOCONFIG["dbuser"] = getenv('POSTGRES_USER');
+ $AUTOCONFIG["dbpass"] = getenv('POSTGRES_PASSWORD');
+ $AUTOCONFIG["dbhost"] = getenv('POSTGRES_HOST');
+ $autoconfig_enabled = true;
+}
+
+if ($autoconfig_enabled) {
+ $AUTOCONFIG["dbtableprefix"] = getenv('NEXTCLOUD_TABLE_PREFIX') ?: "";
+
+ $AUTOCONFIG["directory"] = getenv('NEXTCLOUD_DATA_DIR') ?: "/var/www/html/data";
+
+ if (getenv('NEXTCLOUD_ADMIN_USER') && getenv('NEXTCLOUD_ADMIN_PASSWORD')) {
+ $AUTOCONFIG["adminlogin"] = getenv('NEXTCLOUD_ADMIN_USER');
+ $AUTOCONFIG["adminpass"] = getenv('NEXTCLOUD_ADMIN_PASSWORD');
+ }
+}
diff --git a/11.0/fpm-alpine/cron.sh b/11.0/fpm-alpine/cron.sh
new file mode 100755
index 00000000..bb65a1fb
--- /dev/null
+++ b/11.0/fpm-alpine/cron.sh
@@ -0,0 +1,4 @@
+#!/bin/bash
+set -e
+
+exec busybox crond -f -l 0 -L /dev/stdout
diff --git a/11.0/fpm-alpine/entrypoint.sh b/11.0/fpm-alpine/entrypoint.sh
new file mode 100755
index 00000000..9298bb47
--- /dev/null
+++ b/11.0/fpm-alpine/entrypoint.sh
@@ -0,0 +1,60 @@
+#!/bin/bash
+set -e
+
+# version_greater A B returns whether A > B
+function version_greater() {
+ [[ "$(printf '%s\n' "$@" | sort -V | head -n 1)" != "$1" ]];
+}
+
+# return true if specified directory is empty
+function directory_empty() {
+ [ -n "$(find "$1"/ -prune -empty)" ]
+}
+
+function run_as() {
+ if [[ $EUID -eq 0 ]]; then
+ su - www-data -s /bin/bash -c "$1"
+ else
+ bash -c "$1"
+ fi
+}
+
+installed_version="0.0.0~unknown"
+if [ -f /var/www/html/version.php ]; then
+ installed_version=$(php -r 'require "/var/www/html/version.php"; echo "$OC_VersionString";')
+fi
+image_version=$(php -r 'require "/usr/src/nextcloud/version.php"; echo "$OC_VersionString";')
+
+if version_greater "$installed_version" "$image_version"; then
+ echo "Can't start Nextcloud because the version of the data ($installed_version) is higher than the docker image version ($image_version) and downgrading is not supported. Are you sure you have pulled the newest image version?"
+ exit 1
+fi
+
+if version_greater "$image_version" "$installed_version"; then
+ if [ "$installed_version" != "0.0.0~unknown" ]; then
+ run_as 'php /var/www/html/occ app:list' > /tmp/list_before
+ fi
+ if [[ $EUID -eq 0 ]]; then
+ rsync_options="-rlDog --chown www-data:root"
+ else
+ rsync_options="-rlD"
+ fi
+ rsync $rsync_options --delete --exclude /config/ --exclude /data/ --exclude /custom_apps/ --exclude /themes/ /usr/src/nextcloud/ /var/www/html/
+
+ for dir in config data custom_apps themes; do
+ if [ ! -d /var/www/html/"$dir" ] || directory_empty /var/www/html/"$dir"; then
+ rsync $rsync_options --include /"$dir"/ --exclude '/*' /usr/src/nextcloud/ /var/www/html/
+ fi
+ done
+
+ if [ "$installed_version" != "0.0.0~unknown" ]; then
+ run_as 'php /var/www/html/occ upgrade --no-app-disable'
+
+ run_as 'php /var/www/html/occ app:list' > /tmp/list_after
+ echo "The following apps have beed disabled:"
+ diff <(sed -n "/Enabled:/,/Disabled:/p" /tmp/list_before) <(sed -n "/Enabled:/,/Disabled:/p" /tmp/list_after) | grep '<' | cut -d- -f2 | cut -d: -f1
+ rm -f /tmp/list_before /tmp/list_after
+ fi
+fi
+
+exec "$@"